<?php
/*
** Network info
** Created by Reaby
**
** an experimental networking info widget for administartors
**
** Depencies: none
*/
Aseco::registerEvent('onStartup',		'netinfo_onStartup');
//Aseco::addChatCommand('netinfo', 'show some netinfos');
Aseco::registerEvent('onPlayerDisconnect',		'netinfo_disconnect');
Aseco::registerEvent('onPlayerConnect',		'netinfo_connect');
Aseco::registerEvent('onEverySecond', 'netinfo_update');


function netinfo_onStartup ($aseco, $command) 
{
	global $networkInfo;
	$networkInfo = new networkInfo();
	$networkInfo->Aseco = $aseco;
	$networkInfo->Startup();
}

function netinfo_update($aseco) {
	global $networkInfo;
	$aseco->client->query('GetNetworkStats'); 
	$networkInfo->Update( $aseco->client->getResponse() );

	if (count($networkInfo->playerdata) != 0) {
		$networkInfo->UpdateWidget();
	}
}

function netinfo_disconnect($aseco, $command) {
	global $networkInfo;
	$networkInfo->removePlayer( $command->login );
}

function netinfo_connect($aseco, $command) {
	global $networkInfo;
	$networkInfo->playerdata[$command->login] = array();
	$networkInfo->playerdata[$command->login]['StateUpdateLatency'] = array();
	$networkInfo->playerdata[$command->login]['StateUpdatePeriod']= array();
	$networkInfo->playerdata[$command->login]['LatestNetworkActivity']= array();
	$networkInfo->playerdata[$command->login]['PacketLossRate'] = array(); 
}


class networkInfo {
	public $Aseco;
	public $serverdata;
	public $playerdata;
	public $settings;
	private $alerts;
	
function Startup() {
$xml_parser = new Examsly();

if ($settings = $xml_parser->parseXml('networkinfo.xml')) {
      $this->settings = array();
      $this->settings['updateInterval'] = $settings['SETTINGS']['UPDATE_INTERVAL'][0];
   	  $this->settings['manialinkID'] = $settings['SETTINGS']['MANIALINK_ID'][0];
   } else {
      // could not parse XML file
      trigger_error('[networkinfo] Could not read/parse setttings file networkinfo.xml!', E_USER_WARNING);
      return false;
   }
   
   $this->serverdata['RecvNetRate'] = array();
   $this->serverdata['SendNetRate'] = array();
   $this->serverdata['TotalReceivingSize'] = array();
   $this->serverdata['TotalSendingSize'] = array();   
}

function update($data) {
	$this->serverdata['Uptime'] = $data['Uptime'];
	$this->serverdata['NbrConnection'] = $data['NbrConnection'];
	$this->serverdata['MeanConnectionTime'] = $data['MeanConnectionTime'];

	$this->addServerData('RecvNetRate', $data['RecvNetRate']);
	$this->addServerData('SendNetRate', $data['SendNetRate']);
	$this->addServerData('TotalReceivingSize', $data['TotalReceivingSize']);
	$this->addServerData('TotalSendingSize', $data['TotalSendingSize']);
	if (!empty($data['PlayerNetInfos'])){
		foreach( $data['PlayerNetInfos'] as $players ) {
			// log playerdata
			$this->playerdata[$players['Login']]['IPAddress'] = $players['IPAddress'];
			$this->addPlayerData($players['Login'],'StateUpdateLatency', $players['StateUpdateLatency'] );
			$this->addPlayerData($players['Login'],'StateUpdatePeriod', $players['StateUpdatePeriod'] );
			$this->addPlayerData($players['Login'],'LatestNetworkActivity', $players['LatestNetworkActivity'] );
			$this->addPlayerData($players['Login'],'PacketLossRate', $players['PacketLossRate'] );
		
			// Alert handler
			/* if ($players['PacketLossRate'] > 0) {
					$this->addAlert("PacketLoss",$player['Login']);
			}
			
			if ($players['StateUpdateLatency'] > 500) {
					$this->addAlert("Latency",$player['Login']);
			}
			*/
			}
		
	}	
}

function removePlayer($player) {
unset ($this->playerdata[$player]);
}

function addServerData ($target, $data) {
	array_push($this->serverdata[$target],$data);
	if ( count($this->serverdata[$target]) > 10) {
		$this->serverdata[$target] = array_slice($this->serverdata[$target], (count($this->serverdata[$target]) - 10), 10);
	}

	if ( count($this->serverdata[$target]) < 10) {
		$tmp = array();
		for ($i = count($this->serverdata[$target]); $i < 10; $i++) {
			array_push($tmp, ' ');
		}
		$this->serverdata[$target] = array_merge($tmp, $this->serverdata[$target]);
		unset($tmp);
	}
}

function addPlayerData ($login, $target, $data) {
/*	if (count( $this->playerdata[$login][$target]) == 0) { $helper = array(); } else {
		$helper = $this->playerdata[$login][$target];
	} */
	$helper = $this->playerdata[$login][$target];
	array_push($helper,$data);
	
	if ( count($helper) > 10) {
		$helper = array_slice($helper, (count($helper) - 10), 10);
	}

	if ( count($helper) < 10) {
		$tmp = array();
		for ($i = count($helper); $i < 10; $i++) {
			array_push($tmp, ' ');
		}
		$helper = array_merge($tmp, $helper);
		unset($tmp);
	}
	$this->playerdata[$login][$target] = $helper;
}


function updateWidget() {

      $xml = '<?xml version="1.0" encoding="UTF-8"?>
      <manialinks>
      <manialink id="'.$this->settings['manialinkID'].'">
	  <frame posn="26 40 0">
	  <format textsize="1" />';
	  
	  $x = 0;
	  $max = 0;
	  foreach($this->serverdata['RecvNetRate'] as $data) {
	  if ($data > $max_Recv) $max_Recv = $data;
	  }
	  
	  foreach($this->serverdata['RecvNetRate'] as $data) {
		if ($data == ' ') $data = 1;
	  $data = trim($data);
	  if ($max_Recv != 0) {
	  	$bar = ( (int)$data / $max_Recv )*5;
	  } else {
	  $bar = 0.5;
	  }
	  $xml .='<quad posn="'. ( $x ).' 0 0" sizen="0.5 '.-$bar.'" style="BgRaceScore2" substyle="HandleBlue" />';	  	  
	  $x += 0.7;
	  }
   	 $xml .='<label posn="0 -0.5 0" halign="left" text="$s$fffR: '.$data.'" />';
	
	  $x += 2;
	  
	  foreach($this->serverdata['SendNetRate'] as $data2) {
	  if ($data > $max_Send) $max_Send = $data2;
	  }
	  
	  foreach($this->serverdata['SendNetRate'] as $data2) {
		if ($data2 == ' ') $data2 = 1;
	  $data2 = trim($data2);
	  if ($max_Send != 0) {
	  $bar = ( (int)$data2 / $max_Send )*5;
	  } else {
	  $bar = 0.5;
	  }
	  $xml .='<quad posn="'. ( $x ).' 0 0" sizen="0.5 '.-$bar.'" style="BgRaceScore2" substyle="HandleRed" />';	  	  
	  $x += 0.7;
	  }
   	  $xml .='<label posn="9 -0.5 0" halign="left" text="$s$fffS: '.$data2.'" />';
 
      $xml .='
	  </frame>
	  <frame posn="0 0 0"> <format textsize="1" />';
	
/*	 $playerdata = $this->playerdata['reaby']; // show some numeric data on spesific player on server (for testing purposes)
	 
	 $xml .='<label posn="0 0 0" halign="left" text="$s$fffUpdateLatency: '.$playerdata['StateUpdateLatency'][9].'" />';
	 $xml .='<label posn="0 1 0" halign="left" text="$s$fffNetworkActivity: '.$playerdata['LatestNetworkActivity'][9].'" />';
	 $xml .='<label posn="0 2 0" halign="left" text="$s$fffUpdatePeriod: '.$playerdata['StateUpdatePeriod'][9].'" />';
	 $xml .='<label posn="0 3 0" halign="left" text="$s$fffPacketloss: '.$playerdata['PacketLossRate'][9].'" />';
	*/ 
	  
	  $xml .= '</frame>
	   </manialink>
      </manialinks>';

	  foreach ($this->Aseco->server->players->player_list as $player) {
	if ( $this->Aseco->isAnyAdmin($player) )  { 
			$this->Aseco->addCall('SendDisplayManialinkPageToLogin', array($player->login, $xml, 0, false));	
	  }	
	  
	  }
	  

	  }

}

/*function chat_netinfo($aseco, $command) {
global $networkInfo;
	print_r($networkInfo->playerdata['hairwave']);	
}
*/
?>